#[link="armv6k"]
extern "C" {
    pub fn Initialize(define_unpredictable_behaviour: bool, enable_fast_dispatch: bool);
    pub fn Shutdown();
    pub fn Run();

    pub fn SetRegister(n: usize, value: u32);
    pub fn GetRegister(n: usize) -> u32;

    pub fn SetCpsr(value: u32);
    pub fn GetCpsr() -> u32;

    pub fn SetMemoryRead8(cb: unsafe extern fn(usize) -> u8);
    pub fn SetMemoryRead16(cb: unsafe extern fn(usize) -> u16);
    pub fn SetMemoryRead32(cb: unsafe extern fn(usize) -> u32);
    pub fn SetMemoryRead64(cb: unsafe extern fn(usize) -> u64);
    pub fn SetMemoryWrite8(cb: unsafe extern fn(usize, u8));
    pub fn SetMemoryWrite16(cb: unsafe extern fn(usize, u16));
    pub fn SetMemoryWrite32(cb: unsafe extern fn(usize, u32));
    pub fn SetMemoryWrite64(cb: unsafe extern fn(usize, u64));
    pub fn SetInterpreterFallback(cb: unsafe extern fn(u32, usize));
    pub fn SetCallSVC(cb: unsafe extern fn(u32));
    pub fn SetExceptionRaised(cb: unsafe extern fn(u32, i32));
    pub fn SetAddTicks(cb: unsafe extern fn(u64));
    pub fn SetGetTicksRemaining(cb: unsafe extern fn() -> u64);
}
